diff --git a/Documentation/Status.rst b/Documentation/Status.rst
index 37128797f00c..808b6250d356 100644
--- a/Documentation/Status.rst
+++ b/Documentation/Status.rst
@@ -298,9 +298,9 @@ Subpage block size
 ------------------
 
 Most commonly used page sizes are 4KiB, 16KiB and 64KiB. All combinations with
-a 4KiB sector size filesystems are supported. Some features are not compatible
+a 4KiB block size filesystems are supported. Some features are not compatible
 with subpage or require another feature to work. Since btrfs-progs 6.7 the default
-sector size is 4KiB as this allows cross-architecture compatibility.
+block size is 4KiB as this allows cross-architecture compatibility.
 
 .. list-table::
    :header-rows: 1
@@ -317,9 +317,9 @@ sector size is 4KiB as this allows cross-architecture compatibility.
    * - Compression
      - :statusok:`partial support`
      - Only page-aligned ranges can be compressed
-   * - Sectorsize
+   * - Blocksize
      - :statusok:`supported`
-     - The list of supported sector sizes on a given version can be found
+     - The list of supported block sizes on a given version can be found
        in file :file:`/sys/fs/btrfs/features/supported_sectorsizes`
 
 .. _status-zoned:
diff --git a/Documentation/Subpage.rst b/Documentation/Subpage.rst
index 4116f86ee828..44ae55b7bf3e 100644
--- a/Documentation/Subpage.rst
+++ b/Documentation/Subpage.rst
@@ -2,16 +2,17 @@ Subpage support
 ===============
 
 Subpage block size support, or just *subpage* for short, is a feature to allow
-using a filesystem that has different size of data block size (*sectorsize*)
+using a filesystem that has different size of data block size
+(*blocksize*, previously called *sectorsize*)
 and the host CPU page size. For easier implementation the support was limited
 to the exactly same size of the block and page. On x86_64 this is typically
 4KiB, but there are other architectures commonly used that make use of larger
 pages, like 64KiB on 64bit ARM or PowerPC or 16KiB on Apple Silicon. This means
-filesystems created with 64KiB sector size cannot be mounted on a system with
+filesystems created with 64KiB block size cannot be mounted on a system with
 4KiB page size.
 
-Since btrfs-progs 6.7, filesystems are created with a 4KiB sector size by
-default, though it remains possible to create filesystems with other sector sizes
+Since btrfs-progs 6.7, filesystems are created with a 4KiB block size by
+default, though it remains possible to create filesystems with other block sizes
 (such as 64KiB with the "-s 64k" option for :command:`mkfs.btrfs`). This
 ensures that new filesystems are compatible across other architecture variants
 using larger page sizes.
@@ -21,7 +22,7 @@ Requirements, limitations
 
 The initial subpage support has been added in kernel 5.15. Most features are
 already working without problems. On a 64KiB page system, a filesystem with
-4KiB sectorsize can be mounted and used as long as the initial mount succeeds.
+4KiB blocksize can be mounted and used as long as the initial mount succeeds.
 Subpage support is used by default for systems with a non-4KiB page size since
 btrfs-progs 6.7.
 
diff --git a/Documentation/btrfs-convert.rst b/Documentation/btrfs-convert.rst
index 973025aba040..0be54ac4d40a 100644
--- a/Documentation/btrfs-convert.rst
+++ b/Documentation/btrfs-convert.rst
@@ -30,8 +30,8 @@ OPTIONS
 -N|--nodesize <SIZE>
         set filesystem nodesize, the tree block size in which btrfs stores its metadata.
         The default value is 16KiB (16384) or the page size, whichever is bigger.
-        Must be a multiple of the sectorsize, but not larger than 65536. See
-        :doc:`mkfs.btrfs` for more details.
+        Must be a multiple of the block size (previously called "sector size),
+	but not larger than 65536. See :doc:`mkfs.btrfs` for more details.
 -r|--rollback
         rollback to the original ext2/3/4 filesystem if possible
 -l|--label <LABEL>
diff --git a/Documentation/btrfs-man5.rst b/Documentation/btrfs-man5.rst
index 56f9c939d6cd..ad1337b4c39f 100644
--- a/Documentation/btrfs-man5.rst
+++ b/Documentation/btrfs-man5.rst
@@ -182,8 +182,8 @@ supported_checksums
 supported_sectorsizes
         (since: 5.13)
 
-        list of values that are accepted as sector sizes (:command:`mkfs.btrfs --sectorsize`) by
-        the running kernel
+        list of values that are accepted as block sizes (previously known as
+	"sector size", :command:`mkfs.btrfs --sectorsize|--blocksize`) by the running kernel
 
 supported_rescue_options
         (since: 5.11)
diff --git a/Documentation/ch-balance-filters.rst b/Documentation/ch-balance-filters.rst
index 81a0ca8f0345..7eb0a858b875 100644
--- a/Documentation/ch-balance-filters.rst
+++ b/Documentation/ch-balance-filters.rst
@@ -21,8 +21,8 @@ multiple device.
 
 The main reason why you want to have different profiles for data and metadata
 is to provide additional protection of the filesystem's metadata when devices fail,
-since a single sector of unrecoverable metadata will break the filesystem,
-while a single sector of lost data can be trivially recovered by deleting the broken file.
+since a single block of unrecoverable metadata will break the filesystem,
+while a single block of lost data can be trivially recovered by deleting the broken file.
 
 Before changing profiles, make sure there is enough unallocated space on
 existing drives to create new metadata block groups (for filesystems
diff --git a/Documentation/ch-mount-options.rst b/Documentation/ch-mount-options.rst
index 1d968f37c14a..9e498c08ced7 100644
--- a/Documentation/ch-mount-options.rst
+++ b/Documentation/ch-mount-options.rst
@@ -289,10 +289,10 @@ max_inline=<bytes>
         Specify the maximum amount of space, that can be inlined in
         a metadata b-tree leaf.  The value is specified in bytes, optionally
         with a K suffix (case insensitive).  In practice, this value
-        is limited by the filesystem block size (named *sectorsize* at mkfs time),
-        and memory page size of the system. In case of sectorsize limit, there's
+        is limited by the filesystem block size (named *blocksize* at mkfs time),
+        and memory page size of the system. In case of blocksize limit, there's
         some space unavailable due to b-tree leaf headers.  For example, a 4KiB
-        sectorsize, maximum size of inline data is about 3900 bytes.
+        blocksize, maximum size of inline data is about 3900 bytes.
 
         Inlining can be completely turned off by specifying 0. This will increase data
         block slack if file sizes are much smaller than block size but will reduce
diff --git a/Documentation/ch-sysfs.rst b/Documentation/ch-sysfs.rst
index f58db400fcc7..d1024d4570cd 100644
--- a/Documentation/ch-sysfs.rst
+++ b/Documentation/ch-sysfs.rst
@@ -112,7 +112,7 @@ read_policy
 sectorsize
         (RO, since: 3.14)
 
-        Shows the sectorsize of the mounted filesystem.
+        Shows the block size (previously called "sector size") of the mounted filesystem.
 
 
 temp_fsid